//***********************************************************************
//		Vandelay / AppWindow.h
//
//				Copyright (c) 2002-2003 David Blumberg
//						davidblumberg@linux.se
//					Published under the MIT license
//***********************************************************************

#ifndef APP_WINDOW_H
#define APP_WINDOW_H

#include <Alert.h>
#include <Box.h>
#include <Menu.h>
#include <MenuBar.h>
#include <MenuField.h>
#include <MenuItem.h>
#include <PopUpMenu.h>
#include <StringView.h>
#include <TextControl.h>
#include <View.h>
#include <Window.h>
#include "Const.h"

class AppWindow : public BWindow
{
	public:
						AppWindow(BRect frame);
						~AppWindow();
		virtual bool 	QuitRequested();
		virtual void 	MessageReceived(BMessage *message);
	
	private:
		void			Convert(void);
		void			EnableViews(void);
		
		BAlert			*About;
		BBox			*fBox;
		
		BMenu			*File;
		BMenu			*Edit;
		
		BMenuBar		*fMenuBar;
		
		BMenuField		*Categories;
		BMenuField		*FromField;
		BMenuField		*ToField;
		
		BMenuItem		*fMenuItem;
		
		BPopUpMenu		*CatPopMenu;
		BPopUpMenu		*FromMenu;
		BPopUpMenu		*ToMenu;
		
		BStringView		*fStringView;
		
		BTextControl	*Input;
		BTextControl	*Output;
		
		BView 			*fView;
		
		bool			convertEnable;
		
		char 			buffer[17];
		
		double 			input;
		double 			result;
		
		int				category;
		int 			itemIndex;
		int32 			from_index;
		int32 			to_index;
};

#endif // APP_WINDOW_H
