//***********************************************************************
//		Vandelay / Convert.cpp
//
//				Copyright (c) 2002-2003 David Blumberg
//						davidblumberg@linux.se
//					Published under the MIT license
//***********************************************************************

#include <stdio.h>
#include <stdlib.h>
#include "AppWindow.h"


void AppWindow::Convert()
{
	input = atof(Input->Text());
	
	if(convertEnable)
	{
		// Area
		if(category == 0)
		{
			if(from_index == 0 && to_index == 1)		// Acre to Centimeter²
			{
				result = input * 40469000;
				fStringView->SetText("y = x * 40469000");
			}
			else if(from_index == 0 && to_index == 2)	// Acre to Hectare
			{
				result = input * 0.40467808;
				fStringView->SetText("y = x * 0.40467808");
			}
			else if(from_index == 0 && to_index == 3)	// Acre to Inch²
			{
				result = input * 6272695;
				fStringView->SetText("y = x * 6272695");
			}
			else if(from_index == 0 && to_index == 4)	// Acre to Meter²
			{
				result = input * 4046.9;
				fStringView->SetText("y = x * 4046.9");
			}
			else if(from_index == 0 && to_index == 5)	// Acre to Yard²
			{
				result = input * 484;
				fStringView->SetText("y = x * 484");
			}
			else if(from_index == 1 && to_index == 0)	// Centimeter² to Acre
			{
				result = input * 0.000000025;
				fStringView->SetText("y = x * 0.000000025");
			}
			else if(from_index == 1 && to_index == 2)	// Centimeter² to Hectare
			{
				result = input * 0.00000001;
				fStringView->SetText("y = x * 0.00000001");
			}
			else if(from_index == 1 && to_index == 3)	// Centimeter² to Inch²
			{
				result = input * 0.155;
				fStringView->SetText("y = x 0.155");
			}
			else if(from_index == 1 && to_index == 4)	// Centimeter² to Meter²
			{
				result = input * 0.0001;
				fStringView->SetText("y = x * 0.0001");
			}
			else if(from_index == 1 && to_index == 5)	// Centimeter² to Yard²
			{
				result = input * 0.0001196;
				fStringView->SetText("y = x * 0.0001196");
			}
			else if(from_index == 2 && to_index == 0)	// Hectare to Acre
			{
				result = input * 2.4711;
				fStringView->SetText("y = x * 2.4711");
			}
			else if(from_index == 2 && to_index == 1)	// Hectare to Centimeter²
			{
				result = input * 100000000;
				fStringView->SetText("y = x * 100000000");
			}
			else if(from_index == 2 && to_index == 3)	// Hectare to Inch²
			{
				result = input * 15500000;
				fStringView->SetText("y = x * 15500000");
			}
			else if(from_index == 2 && to_index == 4)	// Hectare to Meter²
			{
				result = input * 10000;
				fStringView->SetText("y = x * 10000");
			}
			else if(from_index == 2 && to_index == 5)	// Hectare to Yard²
			{
				result = input * 1196;
				fStringView->SetText("y = x * 1196");
			}
			else if(from_index == 3 && to_index == 0)	// Inch² to Acre
			{
				result = input * 0.000000156;
				fStringView->SetText("y = x * 0.000000156");
			}
			else if(from_index == 3 && to_index == 1)	// Inch² to Centimeter²
			{
				result = input * 6.4516;
				fStringView->SetText("y = x * 6.4516");
			}
			else if(from_index == 3 && to_index == 2)	// Inch² to Hectare
			{
				result = input * 0.000000065;
				fStringView->SetText("y = x * 0.000000065");
			}
			else if(from_index == 3 && to_index == 4)	// Inch² to Meter²
			{
				result = input * 0.00064516;
				fStringView->SetText("y = x * 0.00064516");
			}
			else if(from_index == 3 && to_index == 5)	// Inch² to Yard
			{
				result = input * 0.00077161136;
				fStringView->SetText("y = x * 0.00077161136");
			}
			else if(from_index == 4 && to_index == 0)	// Meter² to Acre
			{
				result = input * 0.00024710272;
				fStringView->SetText("y = x * 0.00024710272");
			}
			else if(from_index == 4 && to_index == 1)	// Meter² to Centimeter²
			{
				result = input * 10000;
				fStringView->SetText("y = x * 10000");
			}
			else if(from_index == 4 && to_index == 2)	// Meter² to Hectare
			{
				result = input * 0.0001;
				fStringView->SetText("y = x * 0.0001");
			}
			else if(from_index == 4 && to_index == 3)	// Meter² to Inch²
			{
				result = input * 1550.031;
				fStringView->SetText("y = x * 1550.031");
			}
			else if(from_index == 4 && to_index == 5)	// Meter² to Yard²
			{
				result = input * 1.1960;
				fStringView->SetText("y = x * 1.1960");
			}
			else if(from_index == 5 && to_index == 0)	// Yard² to Acre
			{
				result = input * 0.0020661157;
				fStringView->SetText("y = x * 0.0020661157");
			}
			else if(from_index == 5 && to_index == 1)	// Yard² to Centimeter²
			{
				result = input * 8361.204034;
				fStringView->SetText("y = x * 8361.204034");
			}
			else if(from_index == 5 && to_index == 2)	// Yard² to Hectare
			{
				result = input * 0.0008361204;
				fStringView->SetText("y = x * 0.0008361204");
			}
			else if(from_index == 5 && to_index == 3)	// Yard² to Inch²
			{
				result = input * 1295.9892;
				fStringView->SetText("y = x * 1295.9892");
			}
			else if(from_index == 5 && to_index == 4)	// Yard² to Meter²
			{
				result = input * 0.8361;
				fStringView->SetText("y = x * 0.8361");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Distance
		else if(category == 1)
		{
			if(from_index == 0 && to_index == 1)		// Foot to Kilometer
			{
				result = (input * 0.3048) / 1000;
				fStringView->SetText("y = (x * 0.3048) / 1000");
			}
			else if(from_index == 0 && to_index == 2)	// Foot to Meter
			{
				result = input * 0.3048;
				fStringView->SetText("y = x * 0.3048");
			}
			else if(from_index == 0 && to_index == 3)	// Foot to Mile(US)
			{
				result = input / 5263.16;
				fStringView->SetText("y = x / 5263.16");
			}
			else if(from_index == 1 && to_index == 0)	// Kilometer to Foot
			{
				result = (input * 3.2808) * 1000;
				fStringView->SetText("y = (x * 3.2808) * 1000");
			}
			else if(from_index == 1 && to_index == 2)	// Kilometer to Meter
			{
				result = input * 1000;
				fStringView->SetText("y = x * 1000");
			}
			else if(from_index == 1 && to_index == 3)	// Kilometer to Mile(US)
			{
				result = input * 0.6214;
				fStringView->SetText("y = x * 0.6214");
			}
			else if(from_index == 2 && to_index == 0)	// Meter to Foot
			{
				result = input * 3.2808;
				fStringView->SetText("y = x * 3.2808");
			}
			else if(from_index == 2 && to_index == 1)	// Meter to Kilometer
			{
				result = input / 1000;
				fStringView->SetText("y = x / 1000");
			}
			else if(from_index == 2 && to_index == 3)	// Meter to Mile(US)
			{
				result = (input / 1000) * 0.6214;
				fStringView->SetText("y = (x / 1000) * 0.6214");
			}
			else if(from_index == 3 && to_index == 0)	// Mile(US) to Foot
			{
				result = input * 5263.16;
				fStringView->SetText("y = x * 5263.16");
			}
			else if(from_index == 3 && to_index == 1)	// Mile(US) to Kilometer
			{
				result = input * 1.609;
				fStringView->SetText("y = x * 1.609");
			}
			else if(from_index == 3 && to_index == 2)	// Mile(US) to Meter
			{
				result = (input * 1.609) * 1000;
				fStringView->SetText("y = (x * 1.609) * 1000");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Power
		else if(category == 2)
		{
			if(from_index == 0 && to_index == 1)		// Horsepower to Kilowatt
			{
				result = input * 0.7457;
				fStringView->SetText("y = x * 0.7457");
			}
			else if(from_index == 1 && to_index == 0)	// Kilowatt to Horsepower
			{
				result = input * 1.3410;
				fStringView->SetText("y = x * 1.3410");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Pressure
		else if(category == 3)
		{
			if(from_index == 0 && to_index == 1)		// Bar to Pascal(Pa)
			{
				result = input * 100000;
				fStringView->SetText("y = x * 100000");
			}
			else if(from_index == 0 && to_index == 2)	// Bar to PSI
			{
				result = input * 14.6959;
				fStringView->SetText("y = x * 14.6959");
			}
			else if(from_index == 1 && to_index == 0)	// Pascal(Pa) to Bar
			{
				result = input * 0.00001;
				fStringView->SetText("y = x * 0.00001");
			}
			else if(from_index == 1 && to_index == 2)	// Pascal(Pa) to PSI
			{
				result = input * 0.000145;
				fStringView->SetText("y = x * 0.000145");
			}
			else if(from_index == 2 && to_index == 0)	// PSI to Bar
			{
				result = input * 0.068947;
				fStringView->SetText("y = x * 0.068947");
			}
			else if(from_index == 2 && to_index == 1)	// PSI to Pascal(Pa)
			{
				result = input * 6894.757;
				fStringView->SetText("y = x * 6894.757");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Temperature
		else if(category == 4)
		{
			if(from_index == 0 && to_index == 1)		// Celsius to Fahrenheit
			{
				result = (input * 1.8) + 32.0;
				fStringView->SetText("y = (x * 1.8) + 32.0");
			}
			else if(from_index == 0 && to_index == 2)	// Celsius to Kelvin
			{
				result = input + 273.16;
				fStringView->SetText("y = x + 273.16");
			}
			else if(from_index == 0 && to_index == 3)	// Celsius to Rankine
			{
				result = (input * 1.8) + 492;
				fStringView->SetText("y = (x * 1.8) + 492");
			}
			else if(from_index == 1 && to_index == 0)	// Fahrenheit to Celsius
			{
				result = (input - 32.0) * 5.0 / 9.0;
				fStringView->SetText("y = (x - 32.0) * 5.0 / 9.0");
			}
			else if(from_index == 1 && to_index == 2)	// Fahrenheit to Kelvin
			{
				result = (input - 32.0) * 5.0 / 9.0 + 273.16;
				fStringView->SetText("y = (x - 32.0) * 5.0 / 9.0 + 273.16");
			}
			else if(from_index == 1 && to_index == 3)	// Fahrenheit to Rankine
			{
				result = input + 460;
				fStringView->SetText("y = x + 460");
			}
			else if(from_index == 2 && to_index == 0)	// Kelvin to Celsius
			{
				result = input - 273.16;
				fStringView->SetText("y = x - 273.16");
			}
			else if(from_index == 2 && to_index == 1)	// Kelvin to Fahrenheit
			{
				result = (input - 273.16) * 1.8 + 32.0;
				fStringView->SetText("y = (x - 273.16) * 1.8 + 32.0");
			}
			else if(from_index == 2 && to_index == 3)	// Kelvin to Rankine
			{
				result = (input - 273.16) * 1.8 + 492;
				fStringView->SetText("y = (x - 273.16) * 1.8 + 492");
			}
			else if(from_index == 3 && to_index == 0)	// Rankine to Celsius
			{
				result = (input - 492.0) * 5.0 / 9.0;
				fStringView->SetText("y = (x - 492.0) * 5.0 / 9.0");
			}
			else if(from_index == 3 && to_index == 1)	// Rankine to Fahrenheit
			{
				result = input - 460;
				fStringView->SetText("y = x - 460");
			}
			else if(from_index == 3 && to_index == 2)	// Rankine to Kelvin
			{
				result = (input - 492.0) * 5.0 / 9.0 + 273.16;
				fStringView->SetText("y = (x - 492.0) * 5.0 / 9.0 + 273.16");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Volume
		else if(category == 5)
		{
			if(from_index == 0 && to_index == 1)		// Dm³ to Gallon(US)
			{
				result = input * 0.2642;
				fStringView->SetText("y = x * 0.2642");
			}
			else if(from_index == 0 && to_index == 2)	// Dm³ to Litre
			{
				result = input;
				fStringView->SetText("y = x");
			}
			else if(from_index == 1 && to_index == 0)	// Gallon(US) to Dm³
			{
				result = input * 3.7854;
				fStringView->SetText("y = x * 3.7854");
			}
			else if(from_index == 1 && to_index == 2)	// Gallon(US) to Litre
			{
				result = input * 3.7854;
				fStringView->SetText("y = x * 3.7854");
			}
			else if(from_index == 2 && to_index == 0)	// Litre to Dm³
			{
				result = input;
				fStringView->SetText("y = x");
			}
			else if(from_index == 2 && to_index == 1)	// Litre to Gallon(US)
			{
				result = input * 0.2642;
				fStringView->SetText("y = x * 0.2642");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
		//----------------------------------------------------------------------
		// Weight
		else if(category == 6)
		{
			if(from_index == 0 && to_index == 1)		// Gram to Kilogram
			{
				result = input / 1000;
				fStringView->SetText("y = x / 1000");
			}
			else if(from_index == 0 && to_index == 2)	// Gram to Pound
			{
				result = input / 1000 * 2.2046;
				fStringView->SetText("y = x / 1000 * 2.2046");
			}
			else if(from_index == 1 && to_index == 0)	// Kilogram to Gram
			{
				result = input * 1000;
				fStringView->SetText("y = x * 1000");
			}
			else if(from_index == 1 && to_index == 2)	// Kilogram to Pound
			{
				result = input * 2.2046;
				fStringView->SetText("y = x * 2.2046");
			}
			else if(from_index == 2 && to_index == 0)	// Pound to Gram
			{
				result = input * 453.6;
				fStringView->SetText("y = x * 453.6");
			}
			else if(from_index == 2 && to_index == 1)	// Pound to Kilogram
			{
				result = input * 0.4536;
				fStringView->SetText("y = x * 0.4536");
			}
			else
			{
				result = 0.0;
				fStringView->SetText("Faulty conversion...");
			}
		
			sprintf(buffer, "%f", result);
			Output->SetText(buffer);
		}
	}
}
